/***************************************************************************
                          mainscreen.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mainscreen.h"
#include "button.h"
#include "auriferous.h"
#include "submenu.h"
#include "editor.h"
#include "timer.h"
#include "checker.h"
#include "wheel.h"
#include "config.h"
#include "jukebox.h"

Mainscreen::Mainscreen(Auriferous* _app)
{
	is_quit=false;
	app=_app;
	e_count=0;
	e_scroll=0;
	scroll_c=0;
	scr_t=0;
	fn=0;
	scroll_y=0;
	timer=new Timer;
	etimer=new Timer;
	up=false;

	Jukebox::init((WorldType)(ran(5)));

	editor = new Button(780, 500, app->menu, "Editor");
	config = new Button(620, 540, app->menu, "Config");
	credits = new Button(500, 580, app->menu, "Credits");
	story = new Button(290, 590, app->menu, "Story");
	help = new Button(400, 530, app->menu, "Help");
	quit = new Button(800, 600, app->menu, "Quit");
	game = new Button(170, 564, app->menu, "Play");
	game2 = new Button(150, 500, app->menu, "Multiplayer");


	submenu=new Submenu(app);
}
Mainscreen::~Mainscreen()
{
}
void Mainscreen::actshowall()
{
	if(!submenu->active()==true)
	{
		draw_main_screen();
		if(quit->is_pressed()==true)
		is_quit=true;
		else if(editor->is_pressed()==true)
		new_editor();
		else if(game->is_pressed()==true)
		submenu->new_sub(ONEPLAYER);
		else if(game2->is_pressed()==true)
		submenu->new_sub(TWOPLAYER);
		else if(config->is_pressed()==true)
		submenu->new_sub(CONFIG);
		else if(help->is_pressed()==true && scr_t!=1)
		{
			scr_t=1;
			scroll_y=0;
			timer->reset();
		}
		else if(story->is_pressed()==true && scr_t!=2)
		{
			scr_t=2;
			scroll_y=0;
			timer->reset();
		}
		else if(credits->is_pressed()==true && scr_t!=3)
		{
			scr_t=3;
			scroll_y=0;
			scroll_c=0;
			timer->reset();
		}
	}
	else
	{
		submenu->act();
		scr_t=0;
	}
}
void Mainscreen::draw_main_screen()
{
	Resources::Net()->put_screen(0, 0);

	draw_screen();

	Resources::Auriferous()->put_screen(214, 0);

	Resources::Greenframe()->put_screen(212, 150);

	draw_effect();

	Resources::Gfont()->print_center(512, 720, "developed by funthing");
}
bool Mainscreen::quited()
{
	return is_quit;
}
void Mainscreen::draw_effect()
{
		if(e_scroll<265)
		{
			if(etimer->time_elapsed()>=0.01f)	
			e_scroll+=5;
		}
		else
		e_scroll=0;

		if(e_count<3)
		{
			if(etimer->time_elapsed()>=0.01f)	
			{
				e_count+=1;
				etimer->reset();
			}
		}
		else
		e_count=0;

		Resources::Mmeffect()->put_screen(227, 165, e_count);
		Resources::Effectbar()->put_screen(227, e_scroll+150);
}
void Mainscreen::new_editor()
{
	app->menu->freeze_gui(true);
	Editor* editor=new Editor(app);
	editor->run();
	delete editor;
	app->menu->freeze_gui(false);
}
void Mainscreen::draw_screen()
{
	switch(scr_t)
	{
	case 1:
		Help();
	break;
	case 2:
		Story();
	break;
	case 3:
		Credits();
	break;
	}

	if(scr_t==0)
	{
	bool any_activated = false;

	if(quit->is_activated()==true)
	{
		Resources::Cgfont()->print_center(512, 205, "Thank's for\n using my game!\n (:");
		any_activated = true;
	}
	else if(editor->is_activated()==true)
	{
		Resources::Cgfont()->print_center(512, 235, "A editor for\n custom levels");
		any_activated = true;
	}
	else if(game->is_activated()==true)
	{
		Resources::Cgfont()->print_center(512, 235, "Start a new\n singleplayer game");
		any_activated = true;
	}
	else if(game2->is_activated()==true)
	{
		Resources::Cgfont()->print_center(512, 235, "Start a new\n multiplayer game");
		any_activated = true;
	}
	else if(config->is_activated()==true)
	{
		Resources::Cgfont()->print_center(512, 235, "Settings for\n Auriferous");
		any_activated = true;
	}
	else if(help->is_activated()==true)
	{
		Resources::Cgfont()->print_center(512, 265, "Show the help");
		any_activated = true;
	}
	else if(story->is_activated()==true)
	{
		Resources::Cgfont()->print_center(512, 205, "Tells you the\n story behind\n Auriferous");
		any_activated = true;
	}
	else if(credits->is_activated()==true)
	{
		Resources::Cgfont()->print_center(512, 265, "The Credits");
		any_activated = true;
	}

	if (!any_activated)
		intro();
	}

	if(CL_Keyboard::get_keycode(CL_KEY_ESCAPE)==true)
	scr_t=0;
}
void Mainscreen::intro()
{
	if(timer->time_elapsed()<=1.0f)
	{
		if(fn<2)
		fn++;
		else
		fn=0;

		Resources::Funthing()->put_screen(337, 265, fn);
	}
	else
	{
	if(timer->time_elapsed()>9.0f)
	timer->reset();
	}
}
void Mainscreen::Help()
{
	switch(scroll_y)
	{
	case 0:
		Resources::Rfontg()->print_center(512, 170, "Quick reference:");
		Resources::Gfont()->print_center(512, 210, "What is the goal? It's simply you are a\n thief and run through mazes of\n dangers. Stay away of the blue monks\n and acid. To get into the next level you\n must collect all gold (or destroy it) and\n go in the door. Sounds simply but see it!\n You've been warned now here\n that this game makes addict. (-:");
	break;
	case 1:
		Resources::Rfontg()->print_center(512, 170, "Your equipment:");
		
		for(int i=0; i<6; i++)
		{
			Resources::Tiles()->put_screen(235, 210+32*i, 48+i);
			Resources::Tiles()->put_screen(505, 242+32*i, 54+i);
		}

		Resources::Tiles()->put_screen(505, 210, 67);
		Resources::Tiles()->put_screen(525, 210, 66);
		Resources::Tiles()->put_screen(550, 210, 68);
		Resources::Gfont()->print_left(270, 220, "pickaxe");
		Resources::Gfont()->print_left(270, 252, "key for red door");
		Resources::Gfont()->print_left(270, 284, "slimebucket");
		Resources::Gfont()->print_left(270, 316, "opens green door");
		Resources::Gfont()->print_left(270, 348, "exploder");
		Resources::Gfont()->print_left(270, 380, "a extra life");
		Resources::Gfont()->print_left(590, 220, "some bombs!");
		Resources::Gfont()->print_left(540, 252, "befudlementgas");
		Resources::Gfont()->print_left(540, 284, "a trap");
		Resources::Gfont()->print_left(540, 316, "jackhammer");
		Resources::Gfont()->print_left(540, 348, "syringe for speed");
		Resources::Gfont()->print_left(540, 380, "lasertripmine");
		Resources::Gfont()->print_left(540, 412, "glass of acid");
	break;
	case 2:
		Resources::Rfontg()->print_center(512, 170, "The other things:");
		Resources::Gfont()->print_left(270, 220, "green door");
		Resources::Tiles()->put_screen(235, 210, 0);
		Resources::Gfont()->print_left(270, 252, "red door");
		Resources::Tiles()->put_screen(235, 242, 12);
		Resources::Gfont()->print_left(270, 284, "normal door");
		Resources::Tiles()->put_screen(235, 276, 24);
		Resources::Gfont()->print_left(270, 316, "teleporter");
		Resources::Tiles()->put_screen(235, 308, 28);
		Resources::Gfont()->print_left(270, 348, "a Blue Monk");
		Resources::Monk()->put_screen(235, 340, 0);
		Resources::Gfont()->print_left(270, 380, "The Player");
		Resources::Player()->put_screen(235, 372, 0);
		Resources::Gfont()->print_left(540, 220, "normal digable");
		Resources::Atile()->put_screen(505, 210, 8);
		Resources::Gfont()->print_left(540, 252, "unblastable");
		Resources::Atile()->put_screen(505, 242, 40);
		Resources::Gfont()->print_left(540, 284, "slimed turf");
		Resources::Atile()->put_screen(505, 276, 48);
		Resources::Gfont()->print_left(540, 316, "hideout");
		Resources::Atile()->put_screen(505, 308, 56);
		Resources::Gfont()->print_left(540, 348, "danger acid");
		Resources::Atile()->put_screen(505, 340, 72);
		Resources::Atile()->put_screen(505, 340, 64);
		Resources::Gfont()->print_left(540, 380, "the Gold");
		Resources::Tiles()->put_screen(490, 372, 63);
		Resources::Tiles()->put_screen(505, 372, 64);
		Resources::Tiles()->put_screen(520, 372, 65);
		Resources::Gfont()->print_left(650, 415, "Good luck!");
		break;
	case 3:
		Resources::Rfontg()->print_center(512, 170, "Some other:");
		Resources::Gfont()->print_center(512, 210, "Hold down the RCTRL-Key and the\n bombkey of the player who wants suicide\nLCRTL+R: restart level\n Editor:\n + Left-mousebutton: select and paint\n + Right-mousebutton: erase\n + Middle-mousebutton: click on monk, \n    Teleporter, moving for special");
	break;
	}

	
	Resources::Gfont()->print_left(230, 415, "(click to continue)");


	if(CL_Mouse::left_pressed()==true && timer->time_elapsed()>0.3f)
	{
		Resources::Clicknormal()->play();
		scroll_y++;
		timer->reset();
	}

	if(scroll_y>3)
	scr_t=0;
}
void Mainscreen::Credits()
{
	if(scroll_c==32)
	up=false;
	if(scroll_c==0)
	up=true;

	if(!up==true)
	scroll_c--;
	else
	scroll_c++;

	Resources::Rfontg()->print_center(512, 170+scroll_c, "The Credits:");
	Resources::Gfont()->print_center(512, 200+scroll_c, "Code and Graphics by funthing \n\nThanks to:\n-The Clanlib Team (#best Game SDK!#)\n-The Authors of the  Music: \n and addicted contributors\n in advance :)");

	if(CL_Mouse::left_pressed()==true && timer->time_elapsed()>0.3f)
	{
		Resources::Clicknormal()->play();
		scr_t=0;
		timer->reset();
	}
}
void Mainscreen::Story()
{
	Resources::Rfontg()->print_center(512, 170, "The Story behind Auriferous:");

	switch(scroll_y)
	{
	case 0:
		Resources::Gfont()->print_center(512, 210, "#In the year 2500 happened a cruel thing,\n some blue monks had reached the world\n domination. How can this happened?\n Nobody knows this today exactly, but\n some old people who have survived the\n war say: #once the blue plague was here#\n They mean the blue monks which had\n made a spell which make them immortal");
	break;
	case 1:
		Resources::Gfont()->print_center(512, 210, "and invulnerable. So they had easy won\n the war. Most of us were killed by the\n monks. But why do we exist today?\n That\'s because one thing of the\n ingredients of the spell is gold. The blue\n monks have collectet the complete gold\n of the earth and had it put into their\n caves which are deep under the earth.");
	break;
	case 2:
		Resources::Gfont()->print_center(512, 210, "They have planned to come back and\n destroy the complete mankind! To make\n this true they had to wait for the year\n 3000 for a special constellation, today\n it\'s 2999-01-01. One year to deadline!\n\nThe solution sounds simple no gold no\n death, but it\'s in the hands of the monks.");
	break;
	case 3:
		Resources::Gfont()->print_center(512, 210, "So it\'s your job, you must steal all. It\'s\n very dangerous, but you must try it. With\n help of the teleporter technology you can\nget into the caves. But be warned the of\npatrolling monks which bite off your\n head if you touch them, some dangerous\n liquids and some slime. Your equipment\n is perfect. The only weak point of the");
	break;
	case 4:
		Resources::Gfont()->print_center(512, 210, "monks is that they don't notice if you put \nthem the ground under the feeds away,\n this means that you can dig off a hole in\n which they fall. If you like, you can take \na pal on your dangerous mission. So you\n must collect all gold. Hope you succeed,\n you skilled thief.\n good luck!#");
	break;
	}

	Resources::Gfont()->print_left(230, 415, "(click to continue)");
	if(CL_Mouse::left_pressed()==true && timer->time_elapsed()>0.3f)
	{
		Resources::Clicknormal()->play();
		scroll_y++;
		timer->reset();
	}

	if(scroll_y>4)
	scr_t=0;
}