/***************************************************************************
                          maptile_normal.cpp  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "maptile_normal.h"
#include "resources.h"
#include "map.h"
#include "timer.h"
#include "game.h"
#include "map_sample.h"
#include "monk.h"

Maptile_normal::Maptile_normal(int _x, int _y, bool _falling, bool _ladder, WorldType _wt, Map* _map) : Maptile(_x, _y, _wt, _map)
{
	mt=NORMAL;
	have_ladder=_ladder;
	blocking=true;
	fallt=false;
	diggin=false;
	digging=false;
	dspr=0;
	digged=false;

	if(have_ladder==true)
	{
		fallt=false;
		blocking=false;
		mt=LADDER;
	}
	else if(_falling==true)
	{
		fallt=true;
		blocking=false;
		mt=NORMAL;
	}
	
	timer=new Timer;
}
Maptile_normal::~Maptile_normal()
{
}
void Maptile_normal::show()
{
	if(diggin==false)
	sur->put_screen(x, y, spr);
	else if(diggin==true && dspr!=-1)
	sur->put_screen(x, y, dspr);
	
	if(have_ladder==true)
	Resources::Tiles()->put_screen(x, y, 42);
}
void Maptile_normal::act()
{
	if(digging)
	digact();	

	if(!fallt && mt!=LADDER)
	{
		if(map->game->sample->get_map_gameobject(x, y)->get_type()==MONK)
		static_cast <Monk*> (map->game->sample->get_map_gameobject(x, y))->in_hole();
	}
}
void Maptile_normal::dig()
{
	if(digging!=true && !have_ladder && !fallt)
	{
    PLAY(Resources::Accrue());
		digging=true;
		timer->reset();
	}
}
void Maptile_normal::digact()
{
	if(timer->time_elapsed()<=10.0f)
	{	
		if(timer->time_elapsed()>=0.2f)
		{
			diggin=true;
			if(spr>8)
			dspr=spr;
			else
			dspr=spr+8;

			dspr+=8;
		}
		if(timer->time_elapsed()>=0.4f)
		{
			dspr+=8;
			mt=EMPTY;
			blocking=false;
			fallt=true;
			digged=true;	
		}
		if(timer->time_elapsed()>=0.6f)
		{
			map->get_left(this)->fit();
			map->get_down(this)->fit();
			map->get_right(this)->fit();
			map->get_up(this)->fit();
			fit();
			dspr=-1;
		}		
	}
	else if(timer->time_elapsed()>=10.0f)
	{	

		if(spr>8)
		dspr=spr+16;
		else
		dspr=spr+24;

		if(timer->time_elapsed()>=10.2f)
		{
			dspr-=8;
		}
		if(timer->time_elapsed()>=10.4f)
		{
			dspr-=8;
			blocking=true;
			fallt=false;
			digged=false;
			mt=NORMAL;
			map->game->sample->kill(x, y);
			map->get_left(this)->fit();
			map->get_down(this)->fit();
			map->get_right(this)->fit();
			map->get_up(this)->fit();
			fit();
		}
		if(timer->time_elapsed()>=10.6f)
		{
			diggin=false;
			digging=false;
      PLAY(Resources::Digoff());
		}	
	}
}